/*
	IV окружной этап Всероссийской олимпиады школьников по информатике
	24 - 28 марта 2006 г.
	г. Петрозаводск

	Задача B. Пекка развлекается
	Авторы: Д. Власов, А. Николаевский, В.А. Кузнецов
	Решение: М. Бурдин
*/

#include <stdio.h>
#include <string.h>

#define LEN 128
#define BASE 10000
#define SIZE 128

int c[SIZE][SIZE][LEN], r[LEN], cr[LEN];
int a[SIZE];

void add(int *c, int *a, int *b) {
	int i, t = 0;
	for (i = 0; i < LEN; i++) {
		t = a[i] + b[i] + t;
		if (t >= BASE) {
			c[i] = t - BASE;
		 	t = 1;
		}
		else {
			c[i] = t;
			t = 0;
		}
	}
}

void mul(int *c, int *a, int *b) {
	int i, j, t;
	memset(c, 0, sizeof(c[0]) * LEN);
	for (i = 0; i < LEN; i++) {
		t = 0;
	 	for (j = 0; j < LEN - i; j++) {
	 		t = t + c[i + j] + a[i] * b[j];
	 		c[i + j] = t % BASE;
	 		t /= BASE;
	 	}
	}
}

void out(int *c) {
	int i;
	for (i = LEN - 1; i > 0; i--) if (c[i]) break;
	printf("%i", c[i]);
	for (i--; i >= 0; i--) printf("%.4i", c[i]);
}

int main() {
	int i, j, n, s;
	freopen("funny.in", "r", stdin);
	freopen("funny.out", "w", stdout);
	scanf("%i", &n);
	if (n <= 0 || n > 100) return 1;
	s = 0;
	for (i = 0; i < n; i++) {
		scanf("%i", a + i);
		if (a[i] <= 0) return 1;
		s += a[i];
	}
	if (s > 100) return 1;

	for (i = 0; i <= s; i++) {
		memset(c[i][0], 0, sizeof(c[i][0]));
		c[i][0][0] = 1;
		memset(c[i][i], 0, sizeof(c[i][i]));
		c[i][i][0] = 1;
		for (j = 1; j < i; j++) {
		 	add(c[i][j], c[i - 1][j - 1], c[i - 1][j]);
		}
	}

	memset(r, 0, sizeof(r));
	r[0] = 1;
	for (i = 0; i < n; i++) {
		memcpy(cr, r, sizeof(r));
		mul(r, cr, c[s - 1][a[i] - 1]);
		s -= a[i];
	}
	out(r); printf("\n");

	return 0;
}